VERSION 5.00
Object = "{0A77CCF5-052C-11D6-B0EC-00B0D074179C}#1.0#0"; "Tws.ocx"
Object = "{D7286017-9FA8-426E-9C8A-70B64FEB5F47}#2.1#0"; "NSTOrdersAPI.ocx"
Begin VB.Form Form1 
   Caption         =   "NeuroShell Trader Interactive Brokers Link"
   ClientHeight    =   2775
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9405
   Icon            =   "NST TradePump IB Example.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   2775
   ScaleWidth      =   9405
   StartUpPosition =   3  'Windows Default
   WindowState     =   1  'Minimized
   Begin NSTOrdersAPI.NSTOrders NSTOrders1 
      Left            =   240
      Top             =   2040
      _ExtentX        =   1085
      _ExtentY        =   873
      BrokerageFeedBack=   -1  'True
   End
   Begin VB.Timer ReconnectTimer 
      Enabled         =   0   'False
      Interval        =   5000
      Left            =   6480
      Top             =   2040
   End
   Begin TWSLib.Tws Tws1 
      Height          =   255
      Left            =   6300
      TabIndex        =   2
      Top             =   0
      Visible         =   0   'False
      Width           =   2775
      _Version        =   65536
      _ExtentX        =   4895
      _ExtentY        =   450
      _StockProps     =   0
   End
   Begin VB.ListBox List1 
      Height          =   1425
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   8355
   End
   Begin VB.Label Label1 
      Caption         =   "Order status and error messages:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   60
      Width           =   6975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' *********************************************************
' *********************************************************
' NeuroShell Trader Order Constants

Private Const MARKET_ORDER = 1
Private Const STOP_ORDER = 2
Private Const LIMIT_ORDER = 3
Private Const STOPLIMIT_ORDER = 4
Private Const MARKETCLOSE_ORDER = 5

Private Const LONGENTRY_ACTION = 1
Private Const SHORTENTRY_ACTION = 2
Private Const LONGEXIT_ACTION = 3
Private Const SHORTEXIT_ACTION = 4


' *********************************************************
' *********************************************************
' Interactive Brokers Specific Variables

Private Const faProfile = ""
'Private Const faProfile = "NeuroShell"   ' name of IB profile used when trading (to use no profile use faProfile = "")

Private InteractiveBrokers_NextValidOrderId As Long            ' Next valid IB order id
Private InteractiveBrokers_ConnectingFlag As Boolean           ' Flag to indicate connection attempt to brokerage is the first connection
Private InteractiveBrokers_ReConnectingFlag As Boolean         ' Flag to indicate connection attempt brokerage is a reconnection after a disconnect
Private InteractiveBrokers_ConnectError As Long                ' Flag to indicate response of brokerage to a connection attempt
Private InteractiveBrokers_ContractDetailsError As Long        ' Flag to indicate response of brokerage to a verify ticker request
Private InteractiveBrokers_Connected As Boolean                ' Flag to indicate if a connection with brokerage has been established
Private InteractiveBrokers_OrderIdsFilled As New Collection    ' Collection of last 40 order ids filled used to verify that a duplicate order fill notification is not passed along to NeuroShell Trader


' *********************************************************
' *********************************************************
' NeuroShell Trader Events

Private Sub NSTOrders1_Logon(ByVal Account As String, ByVal Password As String, ByRef LoggedOn As Long)
    
    ' *********************************************************
    ' NeuroShell Trader Event requesting brokerage logon
    
    Dim txt As String
    Dim t As Double
    
    ' exit if already InteractiveBrokers_Connected to brokerage
    If InteractiveBrokers_Connected Then Exit Sub
    
    ' Initialize InteractiveBrokers_NextValidOrderId to 1 since Interactive Brokers wants sequential order id's
    InteractiveBrokers_NextValidOrderId = 1
       
    ' show form (if not already visible)
    Me.Show
    
    If faProfile <> "" Then
        List1.AddItem "Interactive Brokers >>> Advisor Account <<< Server."
    Else
        List1.AddItem "Interactive Brokers Individual Account Server"
    End If
    
    ' Display status in list box
    List1.AddItem "About to connect to IB TWS ... Make sure IB TWS is loaded and client support configured"
       
    ' Display connection message in NeuroShell Trader
    txt = "About to establish a connection with Interactive Brokers."
    txt = txt + Chr$(13) + Chr$(13)
    txt = txt + "1) Make sure the IB Trader Workstation is loaded and running before pressing OK."
    txt = txt + Chr$(13) + Chr$(13)
    txt = txt + "2) Verify client support is configured in the IB Trader Workstation.  To configure client support in the IB Trader Workstation, go to the 'Configure' menu, select 'API' and check 'Enable ActiveX and Socket Clients'."
    txt = txt + Chr$(13) + Chr$(13)
    txt = txt + "3) MOST IMPORTANT - After pressing OK, choose Yes on the 'Accept incoming connection attempt' prompt in the IB Trader Workstation." + Chr$(13) + "      *** NOTE: THE IB TRADER WORKSTATION MAY BE BEHIND NEUROSHELL TRADER WINDOW IN SOME CASES. ***"
    NSTOrders1.Message txt
    
    ' Display form
    List1.AddItem "Connecting to IB TWS ... Please select YES to 'Accept incoming connection attempt' in IB Workstation"
    
    ' Connect to Interactive Brokers
    TWS_connect True

    If InteractiveBrokers_Connected Then
        ' Display status in list box
        List1.AddItem "InteractiveBrokers_Connected to IB TWS"
    Else
        WindowState = 0   ' show window/unminimize so user can see errors in list box
        LoggedOn = False  ' Set LoggedOn variable to signal NeuroShell Trader that log on failed
    End If
End Sub

Private Sub NSTOrders1_VerifyTicker(ByVal Ticker As String, ByVal exchange As String, ByVal secType As String, ByRef valid As Long)
    ' *****************************************************************
    ' NeuroShell Trader Event for determining if a ticker, exhange and
    ' security type combination will be accepted by the brokerage.
    
    Dim txt As String
    Dim i As Long
    Dim currencytxt As String
    
    ' exit if not already InteractiveBrokers_Connected to brokerage
    If Not InteractiveBrokers_Connected Then Exit Sub
    
    ' set currency txt
    i = InStr(exchange, "/")
    If i = 0 Then i = InStr(exchange, "\")
    If i > 1 And i <> Len(exchange) Then
        currencytxt = right$(exchange, Len(exchange) - i)
        exchange = Left$(exchange, i - 1)
    Else
        currencytxt = ""
    End If

    ' set contract details error to -1 to signify no return value set
    InteractiveBrokers_ContractDetailsError = -1
    
    ' request contact details
    On Error GoTo VerifyTickerErrorMsg
    Tws1.reqContractDetails2 Ticker, secType, exchange, currencytxt, 0
    On Error GoTo 0
    
    ' wait for return value from contract details request
    While InteractiveBrokers_ContractDetailsError = -1
        DoEvents
    Wend
    
    If InteractiveBrokers_ContractDetailsError = 0 Then
        List1.AddItem "Verified Ticker=" + Ticker + " Exchange=" + exchange + " Currency=" + currencytxt + " SecurityType=" + secType
    Else
        List1.AddItem "Could Not Verify Ticker=" + Ticker + " Exchange=" + exchange + " Currency=" + currencytxt + " SecurityType=" + secType
        valid = 0  ' need to signal that ticker not valid
    End If
    
    Exit Sub

VerifyTickerErrorMsg:
    MsgBox "The currently installed and registered Interactive Brokers API is not compatible with this version of NeuroShell Trader." + Chr$(13) + Chr$(13) + "To restore the compatible Interactive Brokers API (Version " + Format$(App.Major) + "." + Format$(App.Minor) + ") which is automatically installed with NeuroShell Trader:" + Chr$(13) + "  1) Uninstall the 'TWS Interoperability Components' using Add/Remove Programs from Windows Control Panel." + Chr$(13) + "  2) Uninstall NeuroShell Trader" + Chr$(13) + "  3) Erase the files Tws.OCX and TwsSocketClient.DLL from C:\Windows\System32" + Chr$(13) + "  4) Reinstall NeuroShell Trader" + Chr$(13) + "  5) If necessary, reinstall Interactive Brokers Trader Workstation.  However, DO NOT REINSTALL any Interactive Brokers APIs!", vbCritical
    End
End Sub

Private Sub NSTOrders1_NewOrder(OrderId As String, ByVal Action As Long, ByVal shares As Long, ByVal Ticker As String, ByVal OrderType As Long, ByVal StopPrice As Double, ByVal LimitPrice As Double, ByVal Duration As String, ByVal exchange As String, ByVal secType As String, ByVal ChartName As String, ByVal StrategyName As String, ByVal ChartTimeStamp As String)
    ' *****************************************************************
    ' NeuroShell Trader Event signaling a new order needs to be placed
    
    Dim ActionString As String
    Dim OrderTypeString As String
    Dim price As Double
    Dim AuxPrice As Double
    Dim ShortTradingFlag As Boolean
    Dim tif As String
    Dim currencytxt As String
    Dim i As Long
    
    ' exit if not already InteractiveBrokers_Connected to brokerage
    If Not InteractiveBrokers_Connected Then Exit Sub
    
    ' Convert NST Action into appropriate Interactive Brokers ActionString
    Select Case Action
        Case LONGENTRY_ACTION:  ActionString = "BUY"
        Case SHORTENTRY_ACTION: ActionString = "SELL" 'If SecType = "STK" Then ActionString = "SSHORT" Else ActionString = "SELL"
        Case LONGEXIT_ACTION:   ActionString = "SELL"
        Case SHORTEXIT_ACTION:  ActionString = "BUY"
    End Select

    ' Convert NST OrderType into appropriate Interactive Brokers OrderTypeString
    Select Case OrderType
        Case MARKET_ORDER:      OrderTypeString = "MKT"
        Case STOP_ORDER:        OrderTypeString = "STP"
                                AuxPrice = CDbl(CStr(StopPrice))
        Case LIMIT_ORDER:       OrderTypeString = "LMT"
                                price = CDbl(CStr(LimitPrice))
        Case STOPLIMIT_ORDER:   OrderTypeString = "STPLMT"
                                price = LimitPrice
                                AuxPrice = StopPrice
        Case MARKETCLOSE_ORDER: OrderTypeString = "MKTCLS"
    End Select
    
    ' tif -The time in force. Valid values are DAY, GTC, IOC
    If UCase$(Duration) = "DAY" Then
        tif = "DAY"
    Else
        tif = "GTC"
    End If
    
    ' set currency txt
    i = InStr(exchange, "/")
    If i = 0 Then i = InStr(exchange, "\")
    If i > 1 And i <> Len(exchange) Then
        currencytxt = right$(exchange, Len(exchange) - i)
        exchange = Left$(exchange, i - 1)
    Else
        currencytxt = ""
    End If
    
    ' Display sending order status in list box
    List1.AddItem "  " + Format$(CVDate(Date + Time())) + " Placing Order #" + CStr(InteractiveBrokers_NextValidOrderId) + " : " + ActionString + ", " + CStr(shares) + ", " + Ticker + ", " + secType + ", " + exchange + ", " + currencytxt + ", " + OrderTypeString + ", " + CStr(price) + ", " + CStr(AuxPrice) + ", " + faProfile + ", " + tif + "   [" + ChartName + "," + StrategyName + "," + ChartTimeStamp + "]"
    
    ' send order to Interactive Brokers
    On Error GoTo NewOrderErrorMsg
    Tws1.tif = tif
    Tws1.ignoreRth = 1   ' ignoreRth - If set to true, allows triggering of orders outside of regular trading hours
    Tws1.rthOnly = 0      ' rthOnly Regular trading hours only.  yes=1, no=0
    Tws1.placeOrder2 InteractiveBrokers_NextValidOrderId, ActionString, shares, Ticker, secType, exchange, "", currencytxt, OrderTypeString, price, AuxPrice, "", "", "", "", faProfile, ""
    On Error GoTo 0
    
    ' Note: the following are valid Interactive Brokers orders for the same futures symbol
    'Tws1.placeOrder2 InteractiveBrokers_NextValidOrderId, "BUY", 100, "ESU5", "FUT", "GLOBEX", "", "MKT", 0, 0
    'Tws1.placeOrder InteractiveBrokers_NextValidOrderId, "BUY", 100, "ES", "FUT", "200509", 0, "", "GLOBEX", "", "MKT", 0, 0
    
    ' return Interactive Broker's orderid so that subsequent cancel/modify requests are sent with Interactive Broker's orderid instead of NeuroShell's orderid
    OrderId = CStr(InteractiveBrokers_NextValidOrderId)
    
    ' increment interactive broker's next valid order id
    InteractiveBrokers_NextValidOrderId = InteractiveBrokers_NextValidOrderId + 1
    
    Exit Sub
    
NewOrderErrorMsg:
    MsgBox "The currently installed and registered Interactive Brokers API is not compatible with this version of NeuroShell Trader." + Chr$(13) + Chr$(13) + "To restore the compatible Interactive Brokers API (Version " + Format$(App.Major) + "." + Format$(App.Minor) + ") which is automatically installed with NeuroShell Trader:" + Chr$(13) + "  1) Uninstall the 'TWS Interoperability Components' using Add/Remove Programs from Windows Control Panel." + Chr$(13) + "  2) Uninstall NeuroShell Trader" + Chr$(13) + "  3) Erase the files Tws.OCX and TwsSocketClient.DLL from C:\Windows\System32" + Chr$(13) + "  4) Reinstall NeuroShell Trader" + Chr$(13) + "  5) If necessary, reinstall Interactive Brokers Trader Workstation.  However, DO NOT REINSTALL any Interactive Brokers APIs!", vbCritical
    End
End Sub

Private Sub NSTOrders1_ModifyOrder(OrderId As String, StopPrice As Double, LimitPrice As Double)
    ' ****************************************************************
    ' NeuroShell Trader Event signaling an order needs to be modified
    
    MsgBox "Modify order not implemented with this Brokerage", , "NeuroShell Trader Interactive Brokers Link"
End Sub

Private Sub NSTOrders1_CancelOrder(OrderId As String)
    ' ***************************************************************
    ' NeuroShell Trader Event signaling an order needs to be canceled
    
    ' exit if not already InteractiveBrokers_Connected to brokerage
    If Not InteractiveBrokers_Connected Then Exit Sub
    
    ' Display sending order status in list box
    List1.AddItem "  " + Format$(CVDate(Date + Time())) + " Canceling Order #" + CStr(OrderId)
    
    ' send cancel to Interactive Brokers
    On Error GoTo CancelOrderErrorMsg
    Tws1.cancelOrder CLng(OrderId)
    On Error GoTo 0
    
    Exit Sub
    
CancelOrderErrorMsg:
    MsgBox "The currently installed and registered Interactive Brokers API is not compatible with this version of NeuroShell Trader." + Chr$(13) + Chr$(13) + "To restore the compatible Interactive Brokers API (Version " + Format$(App.Major) + "." + Format$(App.Minor) + ") which is automatically installed with NeuroShell Trader:" + Chr$(13) + "  1) Uninstall the 'TWS Interoperability Components' using Add/Remove Programs from Windows Control Panel." + Chr$(13) + "  2) Uninstall NeuroShell Trader" + Chr$(13) + "  3) Erase the files Tws.OCX and TwsSocketClient.DLL from C:\Windows\System32" + Chr$(13) + "  4) Reinstall NeuroShell Trader" + Chr$(13) + "  5) If necessary, reinstall Interactive Brokers Trader Workstation.  However, DO NOT REINSTALL any Interactive Brokers APIs!", vbCritical
    End
End Sub

Private Sub NSTOrders1_Logoff()
    ' *********************************************************
    ' NeuroShell Trader Event requesting brokerage logoff
    
    ' exit if not already InteractiveBrokers_Connected to brokerage
    If Not InteractiveBrokers_Connected Then Exit Sub
    
    ' disconnect from Interactive Brokers
    On Error GoTo LogOffErrorMsg
    Tws1.disconnect
    On Error GoTo 0
    InteractiveBrokers_Connected = False
    
    Exit Sub
    
LogOffErrorMsg:
    MsgBox "The currently installed and registered Interactive Brokers API is not compatible with this version of NeuroShell Trader." + Chr$(13) + Chr$(13) + "To restore the compatible Interactive Brokers API (Version " + Format$(App.Major) + "." + Format$(App.Minor) + ") which is automatically installed with NeuroShell Trader:" + Chr$(13) + "  1) Uninstall the 'TWS Interoperability Components' using Add/Remove Programs from Windows Control Panel." + Chr$(13) + "  2) Uninstall NeuroShell Trader" + Chr$(13) + "  3) Erase the files Tws.OCX and TwsSocketClient.DLL from C:\Windows\System32" + Chr$(13) + "  4) Reinstall NeuroShell Trader" + Chr$(13) + "  5) If necessary, reinstall Interactive Brokers Trader Workstation.  However, DO NOT REINSTALL any Interactive Brokers APIs!", vbCritical
    End
End Sub

Private Sub NSTOrders1_Unload()
    ' ****************************************************************************************
    ' NeuroShell Trader Event triggered when NeuroShell Trader wants the application to unload
    
    Unload Me   ' unload application when NeuroShell Requests Unload
End Sub


' *********************************************************
' *********************************************************
' Interactive Broker API Events

Public Sub TWS_connect(reconnect As Boolean)
    ' ****************************************************************************************
    ' Interactive Brokers event that is triggered when an IB connection is established
    ' or reestablished after a disconnect
    
    If InteractiveBrokers_Connected Then Exit Sub
    
    ' Connect to Interactive Brokers
    InteractiveBrokers_ConnectError = 0
    If reconnect Then
        InteractiveBrokers_ReConnectingFlag = True
    Else
        InteractiveBrokers_ConnectingFlag = True
    End If
    On Error GoTo LogonErrorMsg
    Tws1.Connect "", 7496, 2
    On Error GoTo 0
    InteractiveBrokers_ConnectingFlag = False
    InteractiveBrokers_ReConnectingFlag = False
    
    If InteractiveBrokers_ConnectError = 0 Then InteractiveBrokers_Connected = True
    
    Exit Sub

LogonErrorMsg:
    MsgBox "Couldn't connect to IB TWS.  Iinstalled and registered Interactive Brokers API may not be compatible with this version of NeuroShell Trader." + Chr$(13) + Chr$(13) + "To restore compatible Interactive Brokers API (Version " + Format$(App.Major) + "." + Format$(App.Minor) + ") which is installed with NeuroShell Trader:" + Chr$(13) + "  1) Uninstall 'TWS Interoperability Components' using Add/Remove Programs from Windows Control Panel." + Chr$(13) + "  2) Uninstall NeuroShell Trader" + Chr$(13) + "  3) Erase Tws.OCX and TwsSocketClient.DLL from C:\Windows\System32" + Chr$(13) + "  4) Reinstall NeuroShell Trader" + Chr$(13) + "  5) If necessary, reinstall Interactive Brokers Trader Workstation.  However, DO NOT REINSTALL any Interactive Brokers APIs!", vbCritical
    End
End Sub

Private Sub Tws1_connectionClosed()
    ' ****************************************************************************************
    ' Interactive Brokers event that is triggered when TWS closes the sockets connection with
    ' the ActiveX control, or when TWS is shut down.
    
    Dim t As Timer
    
    InteractiveBrokers_Connected = False
    NSTOrders1.Disconnected
    
    ' Display message in NeuroShell Trader that the Interactive Brokers connection was closed
    List1.AddItem "The IB Trader Workstation was either shutdown or the IB Trader Workstation closed the sockets connection.  Trades can not be sent to Interactive Brokers until a link with the IB Trader Workstation is reestablished."
    NSTOrders1.Message "The IB Trader Workstation was either shutdown or the IB Trader Workstation closed the sockets connection.  Trades will not be sent to Interactive Brokers until a link with the IB Trader Workstation is reestablished."
    
    ' turn on reconnect timer to try to reconnect (in case user opens it again)
    ReconnectTimer.Enabled = True
End Sub

Private Sub Tws1_contractDetails(ByVal symbol As String, ByVal secType As String, ByVal expiry As String, ByVal strike As Double, ByVal right As String, ByVal exchange As String, ByVal curency As String, ByVal localSymbol As String, ByVal marketName As String, ByVal tradingClass As String, ByVal conid As Long, ByVal minTick As Double, ByVal priceMagnifier As Long, ByVal multiplier As String, ByVal orderTypes As String, ByVal validExchanges As String)
    ' ****************************************************************************************
    ' Interactive Broker's event that is fired when the reqContractDetails()
    ' or reqContractDetails2() methods are invoked
    
    ' Contracts details request was sucessful
    InteractiveBrokers_ContractDetailsError = 0
End Sub

Private Sub Tws1_nextValidId(ByVal id As Long)
    ' **************************************************************************************************
    ' Interactive Broker's event that occurs after a successful connection to the Interactive Broker TWS
    ' id = next available order ID received from Interactive Brokers TWS upon connection.
    '      Increment all successive orders by one based on this ID.
    
    ' store brokerage's next valid order id
    InteractiveBrokers_NextValidOrderId = id
End Sub

Private Sub Tws1_orderStatus(ByVal id As Long, ByVal status As String, ByVal filled As Long, ByVal remaining As Long, ByVal avgFillPrice As Double, ByVal permId As Long, ByVal parentId As Long, ByVal lastFillPrice As Double, ByVal clientId As Long, ByVal whyHeld As String)
    ' **************************************************************************************************
    ' Interactive Broker's event that occurs whenever the status of an order changes.
    
    Dim txt As String
    
    If status = "Filled" Then
        If filled > 0 Then
            If lastFillPrice <> 0 Then   ' attempt to get rid of double fill notifications where first lastfilledprice usually equals avgFillPrice, but second one has lastfilledprice of zero
                If remaining = 0 Then
                    ' check that not a duplicate fill notification (otherwise NeuroShell will fill twice as many shares as needed)
                    On Error Resume Next
                    txt = InteractiveBrokers_OrderIdsFilled(CStr(id))
                    On Error GoTo 0
                    If txt <> "" Then Exit Sub   ' duplicate fill notification, so don't process
                    
                    If InteractiveBrokers_OrderIdsFilled.Count >= 40 Then InteractiveBrokers_OrderIdsFilled.Remove 1   ' only keep the last 40 ids for speed and memory purposes
                    InteractiveBrokers_OrderIdsFilled.Add id, CStr(id)   ' add the orderid to the orderfilled collection for future duplicate order id checks
                End If
                
                If filled > 1 Then
                    List1.AddItem "    " + Format$(CVDate(Date + Time())) + " Order #" + CStr(id) + " Filled: " + Format$(filled) + " shares/contracts/lots at an average price of " + Format$(avgFillPrice)
                Else
                    List1.AddItem "    " + Format$(CVDate(Date + Time())) + " Order #" + CStr(id) + " Filled: " + Format$(filled) + " share/contract/lot at an average price of " + Format$(avgFillPrice)
                End If
                
                ' notify NeuroShell that order filled
                If NSTOrders1.OrderFilled(CStr(id), filled, avgFillPrice) = 0 Then List1.AddItem "    " + "******** Order Fill Notification Failed *********"
            End If
        End If
    ElseIf status = "Cancelled" Then
        List1.AddItem "    " + Format$(CVDate(Date + Time())) + " Order #" + CStr(id) + " Cancelled"
        
        ' notify NeuroShell that order canceled
        If NSTOrders1.OrderCanceled(CStr(id)) = 0 Then List1.AddItem "    " + "******** Order Cancel Notification Failed *********"
    ElseIf status = "Inactive" Then    ' status Inactive occurs when error submitting order like "Not enough available short shares to short"
        List1.AddItem "    " + Format$(CVDate(Date + Time())) + " Order #" + CStr(id) + " Inactive"
        
        ' notify NeuroShell that order inactive
        If NSTOrders1.OrderInactive(CStr(id)) = 0 Then List1.AddItem "    " + "******** Order Inactive Notification Failed *********"
    Else
        List1.AddItem "    " + Format$(CVDate(Date + Time())) + " Order #" + CStr(id) + " [" + status + "]"
    End If
End Sub

Private Sub Tws1_errMsg(ByVal id As Long, ByVal errorCode As Long, ByVal errorMsg As String)
    ' ****************************************************************************************
    ' Interactive Broker's error notification event
    
    Dim txt As String
    
    If errorCode >= 2103 And errorCode <= 2109 Then
        ' ignore the following informational error codes
        ' 2103 A market data farm is disconnected.
        ' 2104 A market data farm is InteractiveBrokers_Connected.
        ' 2105 A historical data farm is disconnected.
        ' 2106 A historical data farm is InteractiveBrokers_Connected.
        ' 2107 A historical data farm connection has become inactive but should be available upon demand.
        ' 2108 A market data farm connection has become inactive but should be available upon demand.
    ElseIf errorCode = 2109 And InStr(errorMsg, "Outside Regular Trading Hours") > 0 Then
        ' 2109 Order Event Warning: Attribute Outside Regular Trading Hours is ignored based on the order type and destination. PlaceOrder is now being processed
        '
        ' NOTE: Probably shouldn't block all 2109's due to the following warning:
        '
        ' API developers should keep in mind that the order event warning error code 2109 exists to transmit warnings
        ' about an order placement or modification that will be processed in spite of the situation being warned about.
        ' It has been used in the past to indicate to an API client that a pattern day trader violation could occur on
        ' the next order that will be placed, and could be used in the future to warn of other issues.
    ElseIf errorCode = 135 Then
        ' Ignore the following codes
        ' 135 Could not find order id
    ElseIf errorCode = 503 And InteractiveBrokers_ConnectError Then
        ' 503 TWS is out of date and must be upgraded
        ' ----> but note that this occurs after a 508 which occurs if the user presses NO to accept incoming connection
    ElseIf errorCode = 200 Then
        ' Contracts details request failed
        InteractiveBrokers_ContractDetailsError = 1
    ElseIf (InteractiveBrokers_ConnectingFlag Or InteractiveBrokers_ReConnectingFlag) And (errorCode = 502 Or errorCode = 508) Then
        InteractiveBrokers_ConnectError = 1
        
        If InteractiveBrokers_ReConnectingFlag = False Then
            ' only show initial connection message/prompt to user if first time connection (i.e. not a reconnect)
            WindowState = 0
            
            ' Either the TWS isn't already running or it isn't setup to accept client requests
            ' [502 = 'Couldn't connect to TWS.  Confirm that "Enable ActiveX and Socket Clients" is enabled on the "Settings" menu']
            txt = "NeuroShell Trader failed to established a connection with Interactive Brokers.  The most likely reasons are:"
            txt = txt + Chr$(13) + Chr$(13)
            txt = txt + "1) The IB Trader Workstation was not loaded and running before pressing OK."
            txt = txt + Chr$(13) + Chr$(13)
            txt = txt + "2) Client support was not configured in the IB Trader Workstation.  To configure client support in the IB Trader Workstation, go to the 'Configure' menu, select 'API' and check 'Enable ActiveX and Socket Clients'."
            txt = txt + Chr$(13) + Chr$(13)
            txt = txt + "3) No, was pressed in the IB Trader workstation in response to 'Accept incoming connection attempt'."
            
            List1.AddItem "Couldn't connect to IB Trader Workstation.  Confirm the IB Trader Workstation is running, 'Enable ActiveX and Socket Clients' is enabled on the 'Settings' menu of the IB Trader Workstation, and Yes was pressed to 'Accept incoming connection attempt'."
            NSTOrders1.Message txt
         End If
    ElseIf errorCode <> 202 And errorCode <> 506 And errorCode <> 508 And errorCode <> 0 Then   ' 506=Unexplained Zero Bytes Read (which happens when IBTWS closed before Trader)   ' 508 no bytes or null-terminator found
        If errorCode = 1100 Then
            ' disconnected from brokerage
            NSTOrders1.Disconnected
            
            ' show status in list box
            List1.AddItem "Disconnected from IB"
        ElseIf errorCode = 1101 Or errorCode = 1102 Then
            ' connection reestablished
            NSTOrders1.Reconnected
        End If
        
        ' show all other messages (except order cancled msg which would show up everytime a limit/stop order is cancelled and replaced with a different order
        List1.AddItem Format$(CVDate(Date + Time())) + " OrderId " + CStr(id) + " - ERRMSG " + CStr(errorCode) + ": " + errorMsg
        WindowState = 0
        NSTOrders1.Message "Interactive Brokers Error Code " + Format$(errorCode) + Chr$(13) + Chr$(13) + errorMsg
    End If
End Sub


' *********************************************************
' *********************************************************
' Form events

Private Sub Form_Load()
    ' hide Interactive Brokerage control when form loaded
    Tws1.Visible = False
End Sub

Private Sub Form_Resize()
    ' resize the status list to match the form size
    If Width > List1.Left And Height > List1.Top + Screen.TwipsPerPixelY * 24 + 120 Then List1.Move List1.Left, List1.Top, Width - List1.Left * 2 - Screen.TwipsPerPixelX * 8, Height - 300 - Screen.TwipsPerPixelY * 24 - 120
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    ' If user tries to unload the form, prompt user if a connection is still established with brokerage
    If InteractiveBrokers_Connected And UnloadMode = 0 Then
        If MsgBox("There is still a connection established with Interactive Brokers." + Chr$(13) + Chr$(13) + "Are you sure you want to close the NeuroShell Trader Interactive Brokers Link?", vbQuestion + vbYesNo + vbDefaultButton2, "NeuroShell Trader Interactive Brokers Link") = vbNo Then
            Cancel = True
        End If
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    End   ' to make absolutely sure the program is ending (sometimes it stays around in the processes even though the form is unloaded?)
End Sub


' *********************************************************
' ************************************************************
' Timer control event

Private Sub ReconnectTimer_Timer()
    ' ************************************************************
    ' When time enabled after a disconnect occurs, attempt to
    ' reconnect to Interactive Brokers on each timer event
    ' ************************************************************
    
    ReconnectTimer.Enabled = False
    If InteractiveBrokers_Connected Then Exit Sub
    
    ' try to reconnect to TWS (in case user opens it again after closing TWS)
    TWS_connect True
    
    If InteractiveBrokers_Connected Then
        ' show status in list box
        List1.AddItem "Reconnected to IB TWS"
        
        ' notify NeuroShell Trader that reconnected
        NSTOrders1.Reconnected
    Else
        ' couldn't reconnect, so restart timer to try again
        ReconnectTimer.Enabled = True
    End If
End Sub


